#!/bin/sh

# vim: sw=4 ts=4

for DISK in $(list-devices disk); do
    dd if=/dev/zero of=${DISK} bs=512 count=1
    parted -s ${DISK} mklabel gpt
done

set $(list-devices disk)
let numb=$#/2
DISKA=$1
DISKB=$2
SIZE1=$(fdisk -l "${DISKA}" 2>/dev/null|grep Disk|grep dev|cut -d' ' -f5)
MBR_LIMIT=$((2 * $((1000 ** 4))))

if [ ${SIZE1} -gt ${MBR_LIMIT} ]; then
	gpt=yes
fi
if [ -n "${gpt}" ] || [ -d /sys/firmware/efi ]; then
	# GPT partitioning
	plabel=gpt
else
	plabel=msdos
fi

debconf-set partman-basicfilesystems/choose_label ${plabel}
debconf-set partman-partitioning/choose_label ${plabel}
debconf-set partman-basicfilesystems/default_label ${plabel}
debconf-set partman-partitioning/default_label ${plabel}
debconf-set partman-partitioning/choose_label ${plabel}
	    
debconf-set partman-auto/disk "$DISKA $DISKB"
debconf-set partman-auto/method "raid"


bootsize=256

if [ -d /sys/firmware/efi ]; then
  debconf-set partman-auto/expert_recipe "multiraid :: \
    200 200 200 free $iflabel{ gpt } $reusemethod{ } method{ efi } format{ } . \
    ${bootsize} 50 ${bootsize} raid $primary{ } method{ raid } . \
    128 512 100% raid method{ raid } . \
    1024 10000 1000000000 raid method{ raid } . "
  echo "${DISKA}1" >> /tmp/first_efi_part
  echo "${DISKB}1" >> /tmp/second_efi_parts
elif [ -n "${gpt}" ]; then
  debconf-set partman-auto/expert_recipe "multiraid :: \
    1 1 1 free $iflabel{ gpt } method{ biosgrub } . \
    ${bootsize} 50 ${bootsize} raid $primary{ } method{ raid } . \
    128 512 100% raid method{ raid } . \
    1024 10000 1000000000 raid method{ raid } . "
else
  debconf-set partman-auto/expert_recipe "multiraid :: \
    ${bootsize} 50 ${bootsize} raid $primary{ } method{ raid } . \
    128 512 100% raid method{ raid } . \
    1024 10000 1000000000 raid method{ raid } . "
fi

if [ -n "${gpt}" ]; then
	debconf-set partman-auto-raid/recipe " \
	  1 2 0 ext4 /boot ${DISKA}2#${DISKB}2 . \
	  1 2 0 swap - ${DISKA}3#${DISKB}3 . \
	  1 2 0 ext4 / ${DISKA}4#${DISKB}4 . "
else
	debconf-set partman-auto-raid/recipe " \
	  1 2 0 ext4 /boot ${DISKA}1#${DISKB}1 . \
	  1 2 0 swap - ${DISKA}5#${DISKB}5 . \
	  1 2 0 ext4 / ${DISKA}6#${DISKB}6 . "
fi

debconf-set grub-installer/bootdev "${DISKA} ${DISKB}"
echo "${DISKA} ${DISKB}" >> /tmp/grub_devices
